{$APPTYPE CONSOLE}
{$R+}
var
  f: TextFile;
  st, rc, queue: array of Integer;
  i, j, N, M, R, stC, startQ, endQ: Integer;
  link, rlink: array of array of Integer;
  vis: array of Boolean;

  procedure PutQ(a: Integer);
  begin
    queue[endQ] := a;
    endQ := (endQ + 1) mod Length(queue);
    Assert(endQ <> startQ);
    st[stC] := a;
    Inc(stC);
  end;

  procedure Dfs(a: Integer);
  var
    i: Integer;
  begin
    if vis[a] then exit;
    vis[a] := true;
    for i := 0 to High(link[a]) do
      Dfs(link[a, i]);
  end;

begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N, M);
  SetLength(rc, N);
  SetLength(link, N); SetLength(rlink, N);

  for i := 0 to N - 1 do rc[i] := 0;
  for i := 0 to N - 1 do begin
    Read(f, R);
    SetLength(link[i], R);
    for j := 0 to R - 1 do begin
      Read(f, link[i, j]);
      Dec(link[i, j]);
      Inc(rc[link[i, j]]);
    end;
  end;
  CloseFile(f);
  for i := 0 to N - 1 do begin
    SetLength(rlink[i], rc[i]);
    rc[i] := 0;
  end;
  for i := 0 to N - 1 do
    for j := 0 to High(link[i]) do begin
      stC := link[i, j];
      rlink[stC, rc[stC]] := i;
      Inc(rc[stC]);
    end;

  SetLength(vis, N);
  for i := 0 to N - 1 do vis[i] := false;
  Dfs(M - 1);

  SetLength(queue, N + 1);
  SetLength(st, N); stC := 0;
  for i := 0 to N - 1 do begin
    rc[i] := Length(link[i]);
    if vis[i] and (rc[i] = 0) then PutQ(i);
  end;
  j := -1;
  while startQ <> endQ do begin
    j := queue[startQ];
    if j = M - 1 then break;
    startQ := (startQ + 1) mod Length(queue);
    for i := 0 to High(rlink[j]) do begin
      R := rlink[j, i];
      Dec(rc[R]);
      if vis[R] and (rc[R] = 0) then PutQ(R);
    end;
  end;
  AssignFile(f, 'output.txt'); Rewrite(f);
  if j = M - 1 then begin
    Writeln(f, stC);
    for i := 0 to stC - 1 do
      Write(f, st[i] + 1, ' ');
  end else
    Write(f, 0);
  CloseFile(f);
end.