{$apptype console}

// INCORRECT -- test 3 fails
// O(n^3)

uses
  Types, Math;

var
  m, n: integer;
  sv: array of TIntegerDynArray;
  wasHere: TBooleanDynArray;
  bestK: integer;
  route, bestRoute: TIntegerDynArray;

  
function canGo(ATo: integer): boolean;
var
  i: integer;
begin
  for i := 0 to High(sv[ATo]) do
    if not wasHere[sv[ATo, i]] then begin
      Result := false;
      Exit;
    end;
  Result := true;
end;


procedure dfs(AFrom, ACnt: integer);
var
  i: integer;
begin
  wasHere[AFrom] := true;
  route[ACnt - 1] := AFrom;
  if ACnt >= bestK then
    Exit;
  if (AFrom = m) then begin
    bestK := ACnt;
    Move(route[0], bestRoute[0], bestK * SizeOf(route[0]));
    Exit;
  end;
  for i := 0 to n - 1 do
    if not wasHere[i] and canGo(i) then
      dfs(i, ACnt + 1);
end;


var
  fi, fo: textfile;
  i, t, j: integer;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  Read(fi, n, m);
  Assert(InRange(n, 1, 100));
  Assert(InRange(m, 1, n));
  Dec(m);

  SetLength(sv, n);
  for i := 0 to n - 1 do begin
    Read(fi, t);
    Assert(InRange(t, 0, n - 1));
    SetLength(sv[i], t);
    for j := 0 to t - 1 do begin
      Read(fi, sv[i, j]);
      Dec(sv[i, j]);
      Assert(sv[i, j] <> i);
    end;
  end;

  SetLength(wasHere, n);
  bestK := MaxInt;
  SetLength(route, n);
  SetLength(bestRoute, n);
  for i := 0 to n - 1 do
    if (sv[i] = nil) then begin
      FillChar(wasHere[0], n * SizeOf(wasHere[0]), false);
      dfs(i, 1);
    end;

  if bestK = MaxInt then
    Write(fo, 0)
  else begin
    Write(fo, bestK);
    for i := 0 to bestK - 1 do
      Write(fo, ' ', bestRoute[i] + 1);
  end;

  CloseFile(fo);
  CloseFile(fi);
end.
